library ieee;
use ieee.std_logic_1164.all;

entity statemachine is
  port(Clock: in std_logic;
       s: in std_logic;
       z: in std_logic;
       cout: in std_logic;
       Rsel: out std_logic;
       LR: out std_logic;
       LC: out std_logic;
       ER: out std_logic;
       EA: out std_logic;
       EQ: out std_logic;
       EC: out std_logic);
end statemachine;

architecture statemachine_arch of statemachine is
  type state is (S1,S2,S3,S4);
  signal current_state,next_state: state:= S1;
  begin
    process(current_state,s,z,cout)
      begin
        case(current_state) is
          when S1 =>
            Rsel<='0';LR<='1';LC<='1';ER<='0';EA<='0';EQ<='0';EC<='0';
            if s='1' then next_state<=S2;
            else next_state<=S1;
            end if;
          when S2 =>
            Rsel<='0';LR<='0';LC<='0';ER<='1';EA<='1';EQ<='0';EC<='0';
            next_state<=s3;
          when S3 =>
            Rsel<='1';LC<='0';ER<='0';EA<='0';EQ<='1';EC<='1';
            if cout='1' then LR<='1';
            else LR<='0';
            end if;
            if z='1' then next_state<=S4;
            else next_state<=S2;
            end if;
          when S4 =>
            Rsel<='0';LR<='0';LC<='0';ER<='0';EA<='0';EQ<='0';EC<='0';
            if s='1' then next_state<=S4;
            else next_state<=S1;
            end if;
        end case;
    end process;
      
    process
      begin
        wait until Clock'event and Clock='1';
        current_state<=next_state;
    end process;
end statemachine_arch;
        