library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity adder8b_tb is
end adder8b_tb;

architecture adder8b_tb_arch of adder8b_tb is
  component adder8b
    port(X: in std_logic_vector(7 downto 0);
         Y: in std_logic_vector(7 downto 0);
         CIN: in std_logic;
         S: out std_logic_vector(7 downto 0);
         COUT: out std_logic);
  end component;
  
  signal X,Y,YN,S: std_logic_vector(7 downto 0);
  signal CIN,COUT: std_logic;
  
  begin
    U: adder8b port map(X=>X,Y=>YN,CIN=>CIN,S=>S,COUT=>COUT);
      
    YN<=not Y;
    process
      begin
        X<="00001010";Y<="00011010";CIN<='1';wait for 10 ns;
        X<="10001010";Y<="00001010";CIN<='1';wait for 10 ns;
        X<="01001010";Y<="11101010";CIN<='1';wait for 10 ns;
        X<="10101010";Y<="10101110";CIN<='1';wait for 10 ns;
    end process;

end adder8b_tb_arch;